#ifndef MYMATH_H
#define MYMATH_H

#include <list>
#include <vector>
#include <set>
#include <iostream>
#include <bitset>

using namespace std;
//using std::bitset;
//using std::vector;

typedef unsigned char uchar;
typedef short unsigned int suint;
typedef       unsigned int nuint;
typedef long  unsigned int luint;

typedef vector<nuint> VUI;
typedef vector<suint> VSUI;
typedef vector<uchar> VUC;

typedef vector<nuint>::iterator VUIi;
typedef vector<suint>::iterator VSUIi;
typedef vector<uchar>::iterator VUCi;

typedef vector<bool> VB;

VUI ConvertToVUI(const VSUI& G);
VUI ConvertToVUI(const VUC& G);

VSUI ConvertToVSUI(const VUI& G);
VSUI ConvertToVSUI(const VUC& G);

VUC ConvertToVUC(const VUI& G);
VUC ConvertToVUC(const VSUI& G);

bool operator<=(const VUC& lhs, const VUC& rhs);

list<VUC> PermutationList(suint n, suint k = 0);
//list<VUC> CartesianProduct(suint n, suint k);
list<VUC> AllSubMultiSets(const VUC& G);

const vector<VB>& subsets(nuint n, nuint r);

VSUI RandomPermutation(suint n);
VSUI RandomPermutation(const VSUI& G);
VSUI Identity(suint n);

luint Binomial(luint n, luint r);

VB operator&(const VB& A, const VB& B);
VB operator|(const VB& A, const VB& B);

VUC max(const VUC& lhs, const VUC& rhs);

vector<VB> Transposed(vector<VB> Table);

bool operator<(const VB& A, const VB& B);

nuint SumVI(const VUI& vi);
nuint SumVI(const VUC& vi);
nuint SumVI(const VSUI& vi);
suint SumVB(const VB& vb);

bool NextSubset(VB& G);
VB ToSubset(nuint num);

bool NextMultiset(const VUC& complete, VUC& G);

bool ProbabilityOfTrue(float p);

std::ostream& operator<<(std::ostream& os, const VUI& rhs);
std::ostream& operator<<(std::ostream& os, const VSUI& rhs);
std::ostream& operator<<(std::ostream& os, const VUC& rhs);
std::ostream& operator<<(std::ostream& os, const VB& rhs);

#endif
